#include <iostream>

#include "Hashtable.h"
#include "HashFunctions.h"

using namespace std;

class Movie {
public:
  string title;
  string director;
  int year;
  int rating;

  Movie() {}

  Movie(string title, string director, int year, int rating) {
    /* TODO */
  }

  friend std::ostream& operator<< (std::ostream &out, const Movie& movie);
};

std::ostream& operator<< (std::ostream &out, const Movie& movie) {
  cout << movie.title << " - " << movie.director << ", " << movie.year;
  return out;
}

int main() {
  Hashtable<string, Movie> db(8, &smart_hash);

  Movie m1("Being Human", "Bill Forsyth", 1994, 6);
  Movie m2("Being human", "Toby Whithouse", 2008, 7);
  Movie m3("The edge of seventeen", "Kelly Fremon Craig", 2016, 7);
  Movie m4("Twilight", "Robert Bento", 1998, 10);
  Movie m5("Twilight", "Catherine Hardwicke", 2008, 4);
  Movie m6("Edge of Fear", "Bobby Roth", 2018, 3);
  Movie m7("The edge of love", "John Maybury", 2008, 9);

  cout << "------------------------ Movie DATABASE --------------------------\n";
  /* TODO: Add Movies to hashtable */
  db.print_hashtable();

  cout << "\n\n------------------------ Director LOOKUP -------------------------------\n";
  /* TODO: Print director's work */
  string directorToFind = "Tom Six";

  cout << "\n\n------------------------ Movie LOOKUP ----------------------\n";
  string movie_query = "Twilight";
  /* TODO: Print the movie with movie_query title */

  cout << "\n\n------------------------ Movie DATABASE CLEANUP -------------------\n";
  /* TODO: Remove low rated movies */
  db.print_hashtable();

  return 0;
}
